# List of ideas for ABCI apps
Let's collect as many ideas for ABCI apps as possible with varying complexity so that interested people have a starting point to build something. Later on this could lead to the community writing tutorials and guides around building these first apps and what to watch out for in terms of building deterministic and fast ABCI apps. Overall it will help us to onboard new developers which should increase adoption and expand the ecosystem.

**ABCI Apps:**
* Traceability app
* ICO-specific app. With possibility to make several funding rounds with reasonable caps and milestone.
* Blockchain bridges
* The best e-cash ever
* App that tracks shares and ownership of companies and pays dividends
* Stock exchange
* Invoicing app
* Voting/governance systems
* IPFS - enabling file sharing
* E-voting for board rooms
* Trading one type of coin for another with greater liquidity
* Digitising physical assets such as silver
* Magic the gathering - creating creative and tradable tokens that link back to real-life objects
* [Bravenewcoin](https://bravenewcoin.com/assets/Whitepapers/A-Note-on-Cryptocurrency-Stabilisation-Seigniorage-Shares.pdf)
* [Permissioned Blocks](https://github.com/autocontracts/permissioned-blocks/blob/master/whitepaper.md)
  * I was that guy that won one of the Consensus Hackathon prizes for a mircro-insurance solution  to help farmers in Africa. I combined both Ethermint and IPFS in the solution, and discussed during my presentation about the benefits of using the Tendermint consensus engine over the vanilla Ethereum POW engine in this design. Higher throughput and lower gas fees. 
I've spent the past 6 months in my spare time developing what I've called "Permissioned Blocks" and have written the following technical white paper about the design:
https://github.com/autocontracts/permissioned-blocks/blob/master/whitepaper.md
It's basically p2p file sharing with permissions but also has the ability to make smart contract state information private. A colleague has further developed on my ideas with this paper:
https://gist.github.com/shmookey/e1df57beeea0a2b8e6014bce6c69c0a4
* High Frequency Energy Trading